/*
                             +---------------+  
                             | ConsList      |  
                             +---------------+  
                        +----| ISame fist    | 
                        |    | AList rest    |   
                        |    +---------------+ 
		            	v
            +--------------------------+ 
            | ISame                    |   
	        +--------------------------+
	        | boolean same(ISame that) |
	        +--------------------------+
                        |
                       / \
                       ---
                        |
               --------------------
               |                  |
	+--------------+    +--------------+
	| Book         |    | Song         |
    +--------------+    +--------------+
    | String title |    | String title | 
	| String author|    | int    time  |
	| int    year  |    +--------------+  
    +--------------+

 */	

//to represent a nonempty list of ISame objects
class ConsList<T extends ISame> implements AList<T>, ISame<AList <T>>{

  T first;
  AList<T> rest;

  ConsList(T first, AList<T> rest){
    this.first=first;
    this.rest=rest;
  }

  //is this non-emty list the same as that object   
  public boolean same(AList<T> that){ 
    if (that instanceof ConsList)
      return this.first.same(((ConsList<T>)that).first)
      && this.rest.same(((ConsList<T>)that).rest);
    else 
      return false; 
  } 

  //does this non-emty list contain that object   
  public boolean contains(T that){ 
    if (this.first.same(that))
      return true;
    else 
      return this.rest.contains(that); 
  } 
} 
